  Program
! ***************************************************************************************
! *     Copyright 2006, by George R. Curtis <grcurtis@go.com>. All rights reserved.    *
! ***************************************************************************************
! *   Redistribution and use in source and binary forms, with or without modification,  *
! *   are permitted provided that the following conditions are met:                     *
! *                                                                                     *
! *       1. Redistributions of source code must retain the above copyright             *
! *          notice, this list of conditions and the following disclaimer.              *
! *                                                                                     *
! *       2. Redistributions in binary form must reproduce the above copyright          *
! *          notice, this list of conditions and the following disclaimer in the        *
! *          documentation and/or other materials provided with the distribution.       *
! *                                                                                     *
! *       3. Neither the name of the author nor the names of any contributors may       *
! *          be used to endorse or promote products derived from this software          *
! *          without specific prior written permission.                                 *
! *                                                                                     *
! *       4. If you make changes to the source code it is requested (but not required)  *
! *          that you email your changes to the address listed above so that others     *
! *          may benefit from the improvements.                                         *
! *                                                                                     *
! *      THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND ANY     *
! *      EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED      *
! *      WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE         *
! *      DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR         *
! *      ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL         *
! *      DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR     *
! *      SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER     *
! *      CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  *
! *      OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE      *
! *      USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.       *
! ***************************************************************************************

! **********                                                                   **********
! * *********************************** REQUIREMENTS! ********************************* *
! * * +-----------------------------------------------------------------------------+ * *
! * * | Windows version: Windows 95 and later. See the prototypes for other req's.  | * *
! * * |                                                                             | * *
! * * | Files          : wInfo.CLW  - This file.                                    | * *
! * * |                  wInfo.PRJ  - Project file (or, you can make your own).     | * *
! * * |                  winAPI.ICO - Window icon.                                  | * *
! * * +-----------------------------------------------------------------------------+ * *
! * *********************************************************************************** *
! **********                                                                   **********

! *********************************** Global EQUATEs: ***********************************
CRLF                                   Equate('<13,10>')             ! Carriage-Return/Line-Feed.
CRLF2                                  Equate('<13,10,13,10>')       ! Carriage-Return/Line-Feed * 2.
! Maximum path size (in bytes).
MAX_PATH                               Equate(260)
! Folder equates used with SHGetSpecialFolderPath()
CSIDL_DESKTOP                          Equate(00000000H)
CSIDL_INTERNET                         Equate(00000001H)
CSIDL_PROGRAMS                         Equate(00000002H)
CSIDL_CONTROLS                         Equate(00000003H)
CSIDL_PRINTERS                         Equate(00000004H)
CSIDL_PERSONAL                         Equate(00000005H)
CSIDL_FAVORITES                        Equate(00000006H)
CSIDL_STARTUP                          Equate(00000007H)
CSIDL_RECENT                           Equate(00000008H)
CSIDL_SENDTO                           Equate(00000009H)
CSIDL_BITBUCKET                        Equate(0000000aH)
CSIDL_STARTMENU                        Equate(0000000bH)
CSIDL_MYDOCUMENTS                      Equate(0000000cH)
CSIDL_MYMUSIC                          Equate(0000000dH)
CSIDL_MYVIDEO                          Equate(0000000eH)
CSIDL_DESKTOPDIRECTORY                 Equate(00000010H)
CSIDL_DRIVES                           Equate(00000011H)
CSIDL_NETWORK                          Equate(00000012H)
CSIDL_NETHOOD                          Equate(00000013H)
CSIDL_FONTS                            Equate(00000014H)
CSIDL_TEMPLATES                        Equate(00000015H)
CSIDL_COMMON_STARTMENU                 Equate(00000016H)
CSIDL_COMMON_PROGRAMS                  Equate(00000017H)
CSIDL_COMMON_STARTUP                   Equate(00000018H)
CSIDL_COMMON_DESKTOPDIRECTORY          Equate(00000019H)
CSIDL_APPDATA                          Equate(0000001aH)
CSIDL_PRINTHOOD                        Equate(0000001bH)
CSIDL_LOCAL_APPDATA                    Equate(0000001cH)
CSIDL_ALTSTARTUP                       Equate(0000001dH)
CSIDL_COMMON_ALTSTARTUP                Equate(0000001eH)
CSIDL_COMMON_FAVORITES                 Equate(0000001fH)
CSIDL_INTERNET_CACHE                   Equate(00000020H)
CSIDL_COOKIES                          Equate(00000021H)
CSIDL_HISTORY                          Equate(00000022H)
CSIDL_COMMON_APPDATA                   Equate(00000023H)
CSIDL_WINDOWS                          Equate(00000024H)
CSIDL_SYSTEM                           Equate(00000025H)
CSIDL_PROGRAM_FILES                    Equate(00000026H)
CSIDL_MYPICTURES                       Equate(00000027H)
CSIDL_PROFILE                          Equate(00000028H)
CSIDL_SYSTEMX86                        Equate(00000029H)
CSIDL_PROGRAM_FILESX86                 Equate(0000002aH)
CSIDL_PROGRAM_FILES_COMMON             Equate(0000002bH)
CSIDL_PROGRAM_FILES_COMMONX86          Equate(0000002cH)
CSIDL_COMMON_TEMPLATES                 Equate(0000002dH)
CSIDL_COMMON_DOCUMENTS                 Equate(0000002eH)
CSIDL_COMMON_ADMINTOOLS                Equate(0000002fH)
CSIDL_ADMINTOOLS                       Equate(00000030H)
CSIDL_CONNECTIONS                      Equate(00000031H)
CSIDL_COMMON_MUSIC                     Equate(00000035H)
CSIDL_COMMON_PICTURES                  Equate(00000036H)
CSIDL_COMMON_VIDEO                     Equate(00000037H)
CSIDL_RESOURCES                        Equate(00000038H)
CSIDL_RESOURCES_LOCALIZED              Equate(00000039H)
CSIDL_COMMON_OEM_LINKS                 Equate(0000003aH)
CSIDL_CDBURN_AREA                      Equate(0000003bH)
CSIDL_COMPUTERSNEARME                  Equate(0000003dH)
CSIDL_FLAG_CREATE                      Equate(00008000H)
CSIDL_FLAG_DONT_VERIFY                 Equate(00004000H)
CSIDL_FLAG_NO_ALIAS                    Equate(00001000H)
CSIDL_FLAG_PER_USER_INIT               Equate(00000800H)
CSIDL_FLAG_MASK                        Equate(0000ff00H)
! ********************************* End Global EQUATEs: *********************************

! ****************************** Global data declarations: ******************************
_RECT                                  Group, Type         ! Data structure used by GetWindowRect.
left                                     Long              ! Left side of rectangle.
top                                      Long              ! Top side of rectangle.
right                                    Long              ! Right side of rectangle.
bottom                                   Long              ! Bottom side of rectangle.
                                       End
! **************************** End Global data declarations. ****************************

! ************************************* Global map: *************************************
  Map
    ! ******************************** Local procedures: ********************************
    main                               ()                       ! Main procedure.
    deskSize                           (), String               ! Retrieves desktop size.
    deskDir                            (ULong CSIDL), String    ! Retrieves special folder paths.
    winDir                             (), String               ! Retrieves Windows directory.
    ! ****************************** Windows API functions ******************************
    Module('user32.DLL')
      ! ---------------------------------------------------------------------------------
      ! The GetDesktopWindow function returns a handle to the desktop window. The desktop
      ! window covers the entire screen. The desktop window is the area on top of which
      ! other windows are painted.
      ! ---------------------------------------------------------------------------------
      GetDesktopWindow                 (), UnSigned, Raw, Pascal, Name('GetDesktopWindow'), Proc
      ! ---------------------------------------------------------------------------------
      ! The GetWindowRect function retrieves the dimensions of the bounding rectangle of
      ! the specified window. The dimensions are given in screen coordinates that are
      ! relative to the upper-left corner of the screen.
      ! ---------------------------------------------------------------------------------
      GetWindowRect                    (                                                |
                                        UnSigned                hWnd,                   |
                                        *_RECT                  lpRect                  |
                                       ), Bool, Raw, Pascal, Name('GetWindowRect'), Proc
    End ! Module('user32.DLL')

    Module('kernel32.DLL')
      ! ---------------------------------------------------------------------------------
      ! The GetWindowsDirectory function retrieves the path of the Windows directory. The
      ! Windows directory contains such files as applications, initialization files, and
      ! help files. 
      !
      ! This function is provided primarily for compatibility. Applications should store
      ! code in the Program Files folder and persistent data in the Application Data
      ! folder in the user's profile. For more information, see ShGetFolderPath.
      ! ---------------------------------------------------------------------------------
      GetWindowsDirectory              (                                                |
                                        *CString                lpBuffer,               |
                                        UnSigned                uSize                   |
                                       ), UnSigned, Raw, Pascal, Name('GetWindowsDirectoryA'), Proc
    End ! Module('kernel32.DLL')

    Module('shell32.DLL')
      ! ---------------------------------------------------------------------------------
      ! Retrieves the path of a special folder, identified by its CSIDL.
      !
      ! Requires Windows 95 and later with Internet Explorer 4.0 and later.
      ! ---------------------------------------------------------------------------------
      SHGetSpecialFolderPath           (                                                |
                                        UnSigned                hwndOwner,              |
                                        *CString                lpszPath,               |
                                        Signed                  nFolder,                |
                                        Bool                    fCreate                 |
                                       ), Bool, Raw, Pascal, Name('SHGetSpecialFolderPathA'), Proc
    End ! Module('shell32.DLL')
  End ! Map
! *********************************** End Global map. ***********************************

  CODE
  System{PROP:Icon} = 'wInfo.EXE[0]'                       ! Set default window icon to application icon.
  main()                                                   ! Call our main procedure.

! ***************************************************************************************
main                                   Procedure()
! ***************************************************************************************
sDirQ                                  Queue, Pre(sdQ)     ! Queue to hold special folder info.
sdDesc                                   CString(40)
sdPath                                   CString(MAX_PATH)
                                       End
! ******************************* Declare our main window: ******************************
mWin WINDOW('Windows Information'),AT(,,420,280),FONT('Tahoma',8,,FONT:regular,CHARSET:ANSI),CENTER,IMM,SYSTEM,GRAY,DOUBLE,AUTO
       GROUP(' GetDesktopWindow: '),AT(8,4,404,36),USE(?Group1),BOXED
         PROMPT('This information was retrieved using the GetDesktopWindow() and GetWindowRect() functions.'),AT(16,14,388,),USE(?Prompt1),CENTER
         PROMPT('?gdwSize'),AT(16,26,388,10),USE(?gdwSize),CENTER
       END
       GROUP(' GetWindowsDirectory: '),AT(8,46,404,36),USE(?Group2),BOXED
         PROMPT('This information was retrieved using the GetWindowsDirectory() function.'),AT(16,56,388,10),USE(?Prompt3),CENTER
         PROMPT('?gwdName'),AT(16,68,388,10),USE(?gwdName),CENTER
       END
       GROUP(' SHGetSpecialFolderPath: '),AT(8,88,404,184),USE(?Group3),BOXED
         PROMPT('This information was retrieved using the SHGetSpecialFolderPath() function.<13,10>This is by no means a complete list of the folder information available.<13,10>*****     NOTE:<9>Not all CSIDL''s are valid on all systems.     *****'),AT(16,98,388,24),USE(?Prompt5),CENTER
         LIST,AT(16,132,388,132),USE(?List1),VSCROLL,FORMAT('164L(2)|M~CSIDL~@s40@200L(2)|M~Special Folder~@s255@'),FROM(sDirQ)
       END
     END
! **************************** End of main window definition: ***************************
  CODE                                                     ! Start doing something useful...
  Open(mWin)                                               ! Open our window.
  ?gdwSize{PROP:Text} = deskSize()                         ! Get the desktop window size.
  ?gwdName{PROP:Text} = winDir()                           ! Get the name of the windows directory.
  Do fillQue                                               ! Fill the queue of special folder names.
  ?List1{PROP:LineHeight} = 10                             ! Set the list box line height.
  Accept                                                   ! Wait for the user to close the window.
  End                                                      ! End of Accept loop.
  Return                                                   ! Not absolutely necessary.

! ---------------------------------------------------------------------------------------
fillQue                                Routine
! ---------------------------------------------------------------------------------------
! Simple routine to fill the queue of special folders.
  sdQ:sdDesc = 'CSIDL_DESKTOP'                 ; sdQ:sdPath = deskDir(CSIDL_DESKTOP)                 ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_DESKTOPDIRECTORY'        ; sdQ:sdPath = deskDir(CSIDL_DESKTOPDIRECTORY)        ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_PROGRAMS'                ; sdQ:sdPath = deskDir(CSIDL_PROGRAMS)                ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_PERSONAL'                ; sdQ:sdPath = deskDir(CSIDL_PERSONAL)                ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_STARTUP'                 ; sdQ:sdPath = deskDir(CSIDL_STARTUP)                 ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_MYDOCUMENTS'             ; sdQ:sdPath = deskDir(CSIDL_MYDOCUMENTS)             ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_STARTMENU'        ; sdQ:sdPath = deskDir(CSIDL_COMMON_STARTMENU)        ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_PROGRAMS'         ; sdQ:sdPath = deskDir(CSIDL_COMMON_PROGRAMS)         ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_STARTUP'          ; sdQ:sdPath = deskDir(CSIDL_COMMON_STARTUP)          ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_DESKTOPDIRECTORY' ; sdQ:sdPath = deskDir(CSIDL_COMMON_DESKTOPDIRECTORY) ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_APPDATA'                 ; sdQ:sdPath = deskDir(CSIDL_APPDATA)                 ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_LOCAL_APPDATA'           ; sdQ:sdPath = deskDir(CSIDL_LOCAL_APPDATA)           ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_APPDATA'          ; sdQ:sdPath = deskDir(CSIDL_COMMON_APPDATA)          ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_WINDOWS'                 ; sdQ:sdPath = deskDir(CSIDL_WINDOWS)                 ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_SYSTEM'                  ; sdQ:sdPath = deskDir(CSIDL_SYSTEM)                  ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_PROGRAM_FILES'           ; sdQ:sdPath = deskDir(CSIDL_PROGRAM_FILES)           ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_PROFILE'                 ; sdQ:sdPath = deskDir(CSIDL_PROFILE)                 ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_DOCUMENTS'        ; sdQ:sdPath = deskDir(CSIDL_COMMON_DOCUMENTS)        ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_COMMON_ADMINTOOLS'       ; sdQ:sdPath = deskDir(CSIDL_COMMON_ADMINTOOLS)       ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_ADMINTOOLS'              ; sdQ:sdPath = deskDir(CSIDL_ADMINTOOLS)              ; Add(sDirQ)
  sdQ:sdDesc = 'CSIDL_CDBURN_AREA'             ; sdQ:sdPath = deskDir(CSIDL_CDBURN_AREA)             ; Add(sDirQ)
  Sort(sDirQ, sdQ:sdDesc)
! ***************************************************************************************

! ***************************************************************************************
deskSize                               Procedure()
! ***************************************************************************************
hWnd                                   UnSigned            ! Handle to the window.
rc                                     Group(_RECT).       ! Structure to hold size of window.
  CODE
  ! This procedure gets a handle to the Windows desktop and then calculates the desktop size.
  hWnd = GetDesktopWindow()                                ! Try to get a handle to the desktop.
  If hWnd Then                                             ! If we got a handle then...
    If GetWindowRect(hWnd, rc) > 0 Then                    ! ...try to get the size of the desktop...
      !We have the rectangle of the desktop. Left & top will be zero (0) so the line below could
      ! also be written as: Return('Desktop size: ' & rc.Right & ' wide x ' & rc.Bottom & ' high.')
      Return('Desktop size: ' & rc.Right - rc.Left & ' wide x ' & rc.Bottom - rc.Top & ' high.')
    Else                                                   ! Unable to get the desktop size.
      ! Let the user know there was an error.
      Return('An error occurred while getting the desktop size.')
    End                                                    ! End of If GetWindowRect()
  Else                                                     ! Unable to get the desktop handle.
    ! Let the user know there was an error.
    Return('An error occurred while getting a handle to the desktop.')
  End                                                      ! End of If hWnd.
! ***************************************************************************************

! ***************************************************************************************
deskDir                                Procedure(ULong CSIDL)
! ***************************************************************************************
sDir                                   CString(MAX_PATH)   ! Buffer to hold directory path.
  CODE
  ! This procedure retrieves the path to special Windows folders.
  ! Check for availability of a specific folder.
  If SHGetSpecialFolderPath(0{PROP:Handle}, sDir, CSIDL, 0) = TRUE Then
    Return(sDir)                                           ! We got it, return path to user.
  Else                                                     ! An error occurred.
    ! Let the user know that something is wrong.
    ! NOTE: Not ALL CSIDL's are valid on ALL systems.
    Return('An error has occurred while retrieving the folder name.')
  End
! ***************************************************************************************

! ***************************************************************************************
winDir                                 Procedure
! ***************************************************************************************
wDir                                   CString(MAX_PATH)   ! Buffer to hold directory path.
rVal                                   UnSigned            ! Value returned by GetWindowsDirectory().
  CODE
  ! This procedure retrieves the path to the Windows directory (i.e.: C:\Windows, C:\WinNT, etc...)
  rVal = GetWindowsDirectory(wDir, Size(wDir))             ! Try to get the Windows directory.
  If rVal > 0 Then                                         ! We succeeded.
    Return(wDir & '  (characters in path: ' & rVal & ')')  ! Return the Windows directory and length of the path string.
  End                                                      ! End of If rVal.
! ***************************************************************************************
